Index: /branches/uq/configure.in
===================================================================
--- /branches/uq/configure.in	(revision 5028)
+++ /branches/uq/configure.in	(revision 5029)
@@ -43,8 +43,8 @@
 AC_PROG_MAKE_SET
 
-# Check for C, C++, and FORTRAN 
+# Check for C, C++, and FORTRAN
 AC_PROG_CC
 AC_PROG_CXX
-# Avoid g95 
+# Avoid g95
 AC_PROG_F77([g77 gfortran f77 fort77 f90 xlf xlf90 fl32])
 
@@ -146,5 +146,5 @@
 for dir in \
  ${exec_prefix} \
- ${exec_prefix}/lib ; do 
+ ${exec_prefix}/lib ; do
   tclconfig="${dir}/tclConfig.sh"
   if test -f "$tclconfig" ; then
@@ -171,7 +171,7 @@
 if test "${with_tclsh}" != "no" ; then
   tclsh="tclsh${TCL_VERSION}"
-  if test "${with_tclsh}" = "yes" ; then 
+  if test "${with_tclsh}" = "yes" ; then
     AC_PATH_PROG(TCLSH, ${tclsh}, [], [${exec_prefix}/bin:${PATH}])
-  else 
+  else
     AC_PATH_PROG(TCLSH, ${tclsh}, [], [${with_tclsh}/bin:${with_tclsh}])
   fi
@@ -188,5 +188,5 @@
     [AS_HELP_STRING([--with-vtk[=version]],
         [VTK library version @<:@default=6.0@:>@])],
-    [], 
+    [],
     [with_vtk=yes])
 
@@ -230,5 +230,5 @@
     [AS_HELP_STRING([--enable-vtkdicom],
         [Use vtkDICOM package @<:@default=no@:>@])],
-    [], 
+    [],
     [enable_vtkdicom=no])
 
@@ -296,9 +296,9 @@
 #--------------------------------------------------------------------
 if test "${with_ffmpeg}" != "no" ; then
-  if test "${with_ffmpeg}" = "yes" ; then 
+  if test "${with_ffmpeg}" = "yes" ; then
     AC_PATH_PROG(FFMPEG, ffmpeg, [], $PATH)
-  else 
+  else
     AC_PATH_PROG(FFMPEG, ffmpeg, [], [${with_ffmpeg}/bin:${with_ffmpeg}])
-  fi 
+  fi
   if test "${FFMPEG}x" != "x" ; then
     AC_DEFINE(HAVE_FFMPEG, 1, [Render servers can use ffmpeg])
@@ -342,5 +342,5 @@
   AC_CHECK_FUNCS(av_close_input_file)
   AC_CHECK_FUNCS(avformat_close_input)
-	
+
   AC_CHECK_FUNC(avcodec_find_decoder,,
     AC_MSG_ERROR(oops! no av_codec_find_decoder ?!?))
@@ -598,5 +598,6 @@
     oldtest/Makefile
     oldtest/src/Makefile
+    puq/Makefile
 ])
 AC_OUTPUT
-	
+
Index: /branches/uq/gui/apps/launcher.tcl
===================================================================
--- /branches/uq/gui/apps/launcher.tcl	(revision 5028)
+++ /branches/uq/gui/apps/launcher.tcl	(revision 5029)
@@ -107,7 +107,7 @@
 # Note: We're sourcing the driver file "main.tcl" rather than exec-ing
 #       wish because we want to see stderr and stdout messages when they
-#	are written, rather than when the program completes.  It also 
-#	eliminates one process waiting for the other to complete. If 
-#	"exec" is needed, then the following could be replaced with 
+#	are written, rather than when the program completes.  It also
+#	eliminates one process waiting for the other to complete. If
+#	"exec" is needed, then the following could be replaced with
 #	blt::bgexec.  It doesn't try to redirect stderr into a file.
 set argv $alist
@@ -116,2 +116,3 @@
 }
 source  $mainscript
+puts "Done with launcher"
Index: /branches/uq/gui/scripts/analyzer.tcl
===================================================================
--- /branches/uq/gui/scripts/analyzer.tcl	(revision 5028)
+++ /branches/uq/gui/scripts/analyzer.tcl	(revision 5029)
@@ -1,3 +1,3 @@
-# -*- mode: tcl; indent-tabs-mode: nil -*- 
+# -*- mode: tcl; indent-tabs-mode: nil -*-
 # ----------------------------------------------------------------------
 #  COMPONENT: analyzer - output area for Rappture
@@ -50,9 +50,9 @@
     itk_option define -notebookpage notebookPage NotebookPage ""
 
-    constructor {tool args} { 
-        # defined below 
-    }
-    destructor { 
-        # defined below 
+    constructor {tool args} {
+        # defined below
+    }
+    destructor {
+        # defined below
     }
 
@@ -103,5 +103,5 @@
 itcl::body Rappture::Analyzer::constructor {tool args} {
     set _tool $tool
-
+    puts "Analyzer init"
     # use this to store all simulation results
     set _resultset [Rappture::ResultSet ::\#auto]
@@ -391,4 +391,5 @@
 # ----------------------------------------------------------------------
 itcl::body Rappture::Analyzer::simulate {args} {
+    puts "simulate $args"
     if {$args == "-ifneeded"} {
         # check to see if simulation is really needed
@@ -401,6 +402,6 @@
         }
         set args ""
-    } 
-
+    }
+    puts "simulation needed"
     # simulation is needed -- go to simulation page
     $itk_component(notebook) current simulate
@@ -423,4 +424,6 @@
 
     # execute the job
+    puts "$_tool run $args"
+
     foreach {status result} [eval $_tool run $args] break
 
@@ -443,5 +446,5 @@
     if {$status != 0} {
         $itk_component(runinfo) configure -state normal
-        # Don't erase program error messages. 
+        # Don't erase program error messages.
         # $itk_component(runinfo) delete 1.0 end
         $itk_component(runinfo) insert end "\n\nProblem launching job:\n\n" text
@@ -585,5 +588,5 @@
                     $popup activate $widget below
                 } else {
-                    download now $widget 
+                    download now $widget
                 }
             } else {
@@ -1282,5 +1285,5 @@
             set frame ${sequence}.element($frameNum)
             $xmlobj put ${frame}.index $frameNum
-            
+
             set molecule ${frame}.structure.components.molecule
             $xmlobj put ${molecule}.pdb $contents
@@ -1325,9 +1328,9 @@
                 set frame ${sequence}.element($frameNum)
                 $xmlobj put ${frame}.index $frameNum
-                
+
                 set molecule ${frame}.structure.components.molecule
                 $xmlobj put ${molecule}.lammps $frameContents
                 $xmlobj put ${molecule}.lammpstypemap $typemap
-                
+
                 incr frameNum
                 set frameContents ""
@@ -1345,5 +1348,5 @@
         set frame ${sequence}.element($frameNum)
         $xmlobj put ${frame}.index $frameNum
-        
+
         set molecule ${frame}.structure.components.molecule
         $xmlobj put ${molecule}.lammps $frameContents
@@ -1355,10 +1358,10 @@
 # USAGE: _trajToSequence <xmlobj> ?<path>?
 #
-#       Check for PDB and LAMMPS trajectories in molecule data and rewrite 
-#       the individual models as a sequence of molecules.  Used internally 
+#       Check for PDB and LAMMPS trajectories in molecule data and rewrite
+#       the individual models as a sequence of molecules.  Used internally
 #       to detect any molecule output elements that contain trajectory data.
 #       Trajectories will be converted into sequences of individual molecules.
 #       All other elements will be unaffected. Scans the entire xml tree if a
-#       starting path is not specified.  
+#       starting path is not specified.
 #
 # ----------------------------------------------------------------------
Index: /branches/uq/gui/scripts/gauge.tcl
===================================================================
--- /branches/uq/gui/scripts/gauge.tcl	(revision 5028)
+++ /branches/uq/gui/scripts/gauge.tcl	(revision 5029)
@@ -1,3 +1,3 @@
-# -*- mode: tcl; indent-tabs-mode: nil -*- 
+# -*- mode: tcl; indent-tabs-mode: nil -*-
 # ----------------------------------------------------------------------
 #  COMPONENT: gauge - compact readout for real values
@@ -42,4 +42,6 @@
     itk_option define -sampleheight sampleHeight SampleHeight 0
     itk_option define -log log Log ""
+    itk_option define -varname varname Varname ""
+    itk_option define -label label Label ""
 
     constructor {args} { # defined below }
@@ -56,6 +58,12 @@
     protected method _layout {}
     protected method _log {event args}
+    protected method _change_param_type {choice}
+    protected method _pop_uq {win}
+    protected method _pop_uq_deactivate {}
 
     private variable _value 0  ;# value for this widget
+    private variable _mode exact ;# current mode
+    private variable _pde ""   ;# ProbDistEditor
+    private variable _val ""   ;# value choice combobox
 
     blt::bitmap define GaugeArrow {
@@ -66,5 +74,5 @@
     }
 }
-                                                                                
+
 itk::usual Gauge {
     keep -cursor -font -foreground -background
@@ -76,4 +84,5 @@
 # ----------------------------------------------------------------------
 itcl::body Rappture::Gauge::constructor {args} {
+
     itk_option remove hull.borderwidth hull.relief
     component hull configure -borderwidth 0
@@ -89,4 +98,11 @@
     bind $itk_component(icon) <Configure> [itcl::code $this _redraw]
 
+    itk_component add uq {
+        button $itk_interior.uq -image [Rappture::icon UQ] \
+            -command [itcl::code $this _pop_uq $itk_interior]
+    }
+
+    pack $itk_component(uq) -side right -padx 10
+
     itk_component add -protected vframe {
         frame $itk_interior.vframe
@@ -96,5 +112,5 @@
 
     itk_component add value {
-        label $itk_component(vframe).value -width 7 \
+        label $itk_component(vframe).value -width 20 \
             -borderwidth 1 -relief flat -textvariable [itcl::scope _value]
     } {
@@ -197,108 +213,58 @@
 # ----------------------------------------------------------------------
 itcl::body Rappture::Gauge::value {args} {
-    set onlycheck 0
+    # puts "Gauge value: $args"
+
+    # Query.  Just return the current value.
+    if {[llength $args] == 0} {
+        return $_value
+    }
+
     set i [lsearch -exact $args -check]
     if {$i >= 0} {
         set onlycheck 1
         set args [lreplace $args $i $i]
-    }
-
-    if {[llength $args] == 1} {
-        #
-        # If this gauge has -units, try to convert the incoming
-        # value to that system of units.  Also, make sure that
-        # the value is bound by any min/max value constraints.
-        #
-        # Keep track of the inputted units so we can give a 
-        # response about min and max values in familiar units.
-        #
-        set newval [set nv [string trim [lindex $args 0]]]
-        set units $itk_option(-units)
-        if {"" != $units} {
-            set newval [Rappture::Units::convert $newval -context $units]
-            set nvUnits [Rappture::Units::Search::for $newval]
-            if { "" == $nvUnits} {
-                set msg [Rappture::Units::description $units]
-                error "unrecognized units in value \"$newval\": should be value with units of $msg"
-            }
-            set nv [Rappture::Units::convert $nv \
-                -context $units -to $units -units off]
-
-            # Normalize the units name
-            set newval [Rappture::Units::convert $newval -units off]$nvUnits
-        }
-
-        switch -- $itk_option(-type) {
-            integer {
-                if { [scan $nv "%g" value] != 1 || int($nv) != $value } {
-                    error "bad value \"$nv\": should be an integer value"
-                }
-            }
-            real {
-		# "scan" will reject the number if the string is "NaN" or
-		# "Inf" or the empty string.  It also is accepts large numbers
-		# (e.g. 111111111111111111111) that "string is double"
-		# rejects.  The problem with "scan" is that it doesn't care if
-		# there are extra characters trailing the number (eg. "123a").
-		# The extra %s substitution is used to detect this case.
-                if { [scan $nv "%g%s" dummy1 dummy2] != 1 } {
-                    error "bad value \"$nv\": should be a real number"
-                }
-            }
-        }
-
-        if {"" != $itk_option(-minvalue)} {
-            set convMinVal [set minv $itk_option(-minvalue)]
-            if {"" != $units} {
-                set minv [Rappture::Units::convert $minv \
-                    -context $units -to $units -units off]
-                set convMinVal [Rappture::Units::convert \
-                    $itk_option(-minvalue) -context $units -to $nvUnits]
-            } else {
-                set newval [format "%g" $newval]
-            }
-
-            # fix for the case when the user tries to
-            # compare values like minv=-500 nv=-0600
-            set nv [format "%g" $nv]
-            set minv [format "%g" $minv]
-
-            if {$nv < $minv} {
-                error "minimum value allowed here is $convMinVal"
-            }
-        }
-
-        if {"" != $itk_option(-maxvalue)} {
-            set convMaxVal [set maxv $itk_option(-maxvalue)]
-            if {"" != $units} {
-                set maxv [Rappture::Units::convert $maxv \
-                    -context $units -to $units -units off]
-                set convMaxVal [Rappture::Units::convert \
-                    $itk_option(-maxvalue) -context $units -to $nvUnits]
-            } else {
-                set newval [format "%g" $newval]
-            }
-
-            # fix for the case when the user tries to
-            # compare values like maxv=500 nv=0600
-            set nv [format "%g" $nv]
-            set maxv [format "%g" $maxv]
-
-            if {$nv > $maxv} {
-                error "maximum value allowed here is $convMaxVal"
-            }
-        }
-
-        if {$onlycheck} {
-            return
-        }
-
-        set _value $newval
-
-        _redraw
-        event generate $itk_component(hull) <<Value>>
-
-    } elseif {[llength $args] != 0} {
+    } else {
+        set onlycheck 0
+    }
+
+    if {[llength $args] != 1} {
         error "wrong # args: should be \"value ?-check? ?newval?\""
+    }
+
+    set newval [Rappture::Units::mcheck_range [lindex $args 0] \
+    $itk_option(-minvalue) $itk_option(-maxvalue) $itk_option(-units)]
+
+    set newmode [lindex $newval 0]
+    switch -- $newmode {
+        uniform -
+        gaussian {
+            set _mode $newmode
+        }
+        exact -
+        default {
+            set _mode exact
+        }
+    }
+
+    if {$itk_option(-type) == "integer"} {
+        if { [scan $newval "%g" value] != 1 || int($newval) != $value } {
+            error "bad value \"$newval\": should be an integer value"
+        }
+    }
+
+    if {$onlycheck} {
+        return
+    }
+
+    set _value $newval
+    $itk_component(value) configure -width [string length $_value]
+    _redraw
+    event generate $itk_component(hull) <<Value>>
+
+    if {"" != $_pde} {
+        set val [$_val translate [$_val value]]
+        $_val value $_mode
+        $_pde value $_value
+
     }
     return $_value
@@ -483,4 +449,5 @@
 # ----------------------------------------------------------------------
 itcl::body Rappture::Gauge::_editor {option args} {
+    # puts "Gauge::editor option=$option args=$args"
     if {$itk_option(-state) == "disabled"} {
         return  ;# disabled? then bail out here!
@@ -504,5 +471,4 @@
             }
             set val [lindex $args 0]
-
             if {[catch {value -check $val} result]} {
                 if {[regexp {allowed here is (.+)} $result match newval]} {
@@ -586,4 +552,8 @@
     }
 
+    if {$itk_option(-type) != "integer"} {
+        pack $itk_component(uq) -side right -padx 10
+    }
+
     array set side2anchor {
         left   e
@@ -733,2 +703,44 @@
     }
 }
+
+itcl::body Rappture::Gauge::_pop_uq {win} {
+    # puts "min=$itk_option(-minvalue) max=$itk_option(-maxvalue) units=$itk_option(-units)"
+    set varname $itk_option(-varname)
+    set popup .pop_uq_$varname
+    if { ![winfo exists $popup] } {
+        Rappture::Balloon $popup -title $itk_option(-label)
+        set inner [$popup component inner]
+        frame $inner.type
+        pack $inner.type -side top -fill x
+        label $inner.type.l -text "Parameter Value:"
+        pack $inner.type.l -side left
+
+        set _val [Rappture::Combobox $inner.type.val -width 20 -editable no]
+        pack $_val -side left -expand yes -fill x
+        $_val choices insert end exact "Exact Value"
+        $_val choices insert end uniform "Uniform Distribution"
+        $_val choices insert end gaussian "Gaussian Distribution"
+        bind $_val <<Value>> [itcl::code $this _change_param_type $inner]
+
+        set _pde [Rappture::ProbDistEditor $inner.entry \
+        $itk_option(-minvalue) $itk_option(-maxvalue)]
+        $_val value $_mode
+        $_pde value $_value
+        pack $inner.entry -expand yes -fill both -pady {10 0}
+
+        $popup configure \
+        -deactivatecommand [itcl::code $this _pop_uq_deactivate]
+    }
+    update
+    $popup activate $win right
+}
+
+itcl::body Rappture::Gauge::_pop_uq_deactivate {} {
+    # puts "deactivate [$_pde value]"
+    value [$_pde value]
+}
+
+itcl::body Rappture::Gauge::_change_param_type {inner} {
+    set val [$_val translate [$_val value]]
+    $_pde mode $val
+}
Index: /branches/uq/gui/scripts/main.tcl
===================================================================
--- /branches/uq/gui/scripts/main.tcl	(revision 5028)
+++ /branches/uq/gui/scripts/main.tcl	(revision 5029)
@@ -1,3 +1,3 @@
-# -*- mode: tcl; indent-tabs-mode: nil -*- 
+# -*- mode: tcl; indent-tabs-mode: nil -*-
 #!/bin/sh
 # ----------------------------------------------------------------------
@@ -96,6 +96,10 @@
 }
 
+# mmh
+puts "main.tcl $argv"
+parray params
+
 proc ReadToolParameters { numTries } {
-    incr numTries -1 
+    incr numTries -1
     if { $numTries < 0 } {
 	return
@@ -107,9 +111,9 @@
 	return
     }
-    catch { 
+    catch {
         set f [open $paramsFile "r"]
         set contents [read $f]
         close $f
-        set pattern {^file\((.*)\):(.*)$} 
+        set pattern {^file\((.*)\):(.*)$}
         foreach line [split $contents "\n"] {
             if { [regexp $pattern $line match path rest] } {
@@ -178,5 +182,4 @@
 set installdir [file normalize [file dirname $params(-tool)]]
 $xmlobj put tool.version.application.directory(tool) $installdir
-
 set tool [Rappture::Tool ::#auto $xmlobj $installdir]
 
@@ -358,9 +361,9 @@
     set arrangement [$win.pager cget -arrangement]
     if { $type == "" } {
-        if { $arrangement != "side-by-side" } { 
+        if { $arrangement != "side-by-side" } {
            set type auto
         }
     }
-    if { $arrangement != "side-by-side" && 
+    if { $arrangement != "side-by-side" &&
             ($type == "manual" || $type == "manual-resim" ||
 	     $type == "auto" || $style == "wizard") } {
@@ -389,4 +392,4 @@
     $win.pager current analyzer
 }
-
+puts "DONE main.tcl"
 wm deiconify .main
Index: /branches/uq/gui/scripts/numberentry.tcl
===================================================================
--- /branches/uq/gui/scripts/numberentry.tcl	(revision 5028)
+++ /branches/uq/gui/scripts/numberentry.tcl	(revision 5029)
@@ -1,3 +1,3 @@
-# -*- mode: tcl; indent-tabs-mode: nil -*- 
+# -*- mode: tcl; indent-tabs-mode: nil -*-
 # ----------------------------------------------------------------------
 #  COMPONENT: NumberEntry - widget for entering numeric values
@@ -25,5 +25,4 @@
     public method label {}
     public method tooltip {}
-
     protected method _newValue {}
 
@@ -43,4 +42,7 @@
 # ----------------------------------------------------------------------
 itcl::body Rappture::NumberEntry::constructor {owner path args} {
+    puts "NumberEntry '$path' '$args'"
+    set varname [lindex [split $path ()] 1]
+
     if {[catch {$owner isa Rappture::ControlOwner} valid] != 0 || !$valid} {
         error "bad object \"$owner\": should be Rappture::ControlOwner"
@@ -48,5 +50,6 @@
     set _owner $owner
     set _path $path
-    
+
+    puts "LABEL=[label]"
     #
     # Figure out what sort of control to create
@@ -58,7 +61,8 @@
         lappend presets $value $label
     }
-    
+
     set class Rappture::Gauge
     set units [string trim [$_owner xml get $path.units]]
+    puts "units=$units"
     if {$units != ""} {
         set desc [Rappture::Units::description $units]
@@ -67,5 +71,5 @@
         }
     }
-    
+
     #
     # Create the widget and configure it properly based on other
@@ -73,17 +77,17 @@
     #
     itk_component add gauge {
-        $class $itk_interior.gauge -units $units -presets $presets -log $path
+        $class $itk_interior.gauge -units $units -presets $presets -log $path -varname $varname -label [label]
     }
     pack $itk_component(gauge) -expand yes -fill both
     bind $itk_component(gauge) <<Value>> [itcl::code $this _newValue]
-    
+
     set min [string trim [$_owner xml get $path.min]]
-    if {$min ne ""} { 
-        $itk_component(gauge) configure -minvalue $min 
-    }
-    
+    if {$min ne ""} {
+        $itk_component(gauge) configure -minvalue $min
+    }
+
     set max [string trim [$_owner xml get $path.max]]
-    if {$max ne ""} { 
-        $itk_component(gauge) configure -maxvalue $max 
+    if {$max ne ""} {
+        $itk_component(gauge) configure -maxvalue $max
     }
 
@@ -119,6 +123,7 @@
     #
     set str [string trim [$_owner xml get $path.default]]
-    if {$str ne ""} { 
-        $itk_component(gauge) value $str 
+    puts "Default=$str"
+    if {$str ne ""} {
+        $itk_component(gauge) value $str
     }
 }
